local _,N = ...
local Settings = {}
N.Settings = Settings
local D = LibStub:GetLibrary("DoomCore-2.0")
local opt = D.opt

local defaults = {}

defaults.conversation = {
  friendship = true,
  friendshipColor = {r=1,g=0,b=0,a=0.66},
  read = true,
  autoconfirm = true,
  completeRewards = true,
  anchor = "bottom",
  slideSpeed = 10,
  adjustAlerts = true,
  width = 570,
  scale = 0.9,
  offsetX = 0,
  offsetY = 96,
  animate = "once",
  buttonWidth = 250,
  buttonHeight = 40,
  buttonScale = 1,
  perRow = 3,
  differentHeights = false,
  -- Keybindings
  next = "SPACE",
  auto = "TAB",
  back = "BACKSPACE",
  close = "ESCAPE",
  reveal = "CTRL-BACKSPACE",
  ["1"] = "1",
  ["2"] = "2",
  ["3"] = "3",
  ["4"] = "4",
  ["5"] = "5",
  ["6"] = "6",
  ["7"] = "7",
  ["8"] = "8",
  ["9"] = "9",
  ["10"] = "0",
  ["11"] = "-",
  ["12"] = "=",
  titleFont = "Morpheus",
  titleSize = 22,
  textFont = "Friz Quadrata TT",
  textSize = 16,
  choiceFont = "Friz Quadrata TT",
  choiceSize = 14
}
defaults.talkinghead = {

}
defaults.chat = {
  slideSpeed = 5,
  yell = true,
  say = false,
  whisper = false,
  none = false,
  dungeon = true,
  raid = true,
  outofcombat = true,
  incombat = false,
  animate = "loop"
}
defaults.rp = {
  slideSpeed = 5
}
defaults.main = {
}
defaults.db = {
  profile = {
  }
}
--local function isAlert(info)
--  return N.Handler.core[info[1]].adjustAlerts
--end]]
local isAlert = { "adjustAlerts" }
defaults.options = opt("parent", {
  set = "Rebuild",
  childGroups = "tab",
  args = {
    { "conversation", "group", { args = {
      { "friendship", "toggle", "Show friendship bar" },
      { "friendshipColor", "aColor", "Bar color" },
      { "space" },
      { "read", "toggle", "Use for reading books", { width = "full" } },
      { "autoconfirm", "toggle", "Skip dialogue confirmations", { width = "full" } },
      { "finished", "toggle", "Show completed tasks", { width = "full" } },
      { "completeRewards", "toggle", "Show rewards when completing a quest", { width = "full" } },
      { "rewards", "toggle", "Include rewards in objective description", { width = "full" } },
      { "conceal", "toggle", "Hide UI while talking", { width = "full" } },
      { "atStart", "toggle", "Show choices at start of dialogue", { width = "full" } },
      { "slideshow", "toggle", "Progress automatically" },
      { "slideSpeed", "range", "Delay (s)", {
        min = 0.5,
        max = 60,
        softMax = 20,
        disabled = ({ false, "slideshow" })
      } },
      { "frame", "header" },
      { "width", "range", {
        min = 10,
        max = UIParent:GetWidth() or 100,
        softMin = 50,
        softMax = 700
      } },
      { "scale" },
      { "space" },
      { "adjustAlerts", "toggle", "Treat as alert" },
      { "anchor", { disabled = isAlert } },
      { "space", },
      { "offsetX", { disabled = isAlert } },
      { "offsetY", { disabled = isAlert } },
      { "space" },
      { "animate", "select", "Animate talking heads", {
        values = { "once", "never", "loop" }
      } },
      { "choices", "header" },
      { "buttonWidth", "range", "Width", {
        min = 10,
        max = 500,
        softMin = 50
      } },
      { "buttonHeight", "range", "Height", {
        min = 10,
        max = 500,
        softMax = 200
      } },
      { "buttonScale", "scale", "Scale" },
      { "perRow", "range", "Per row", {
        min = 1,
        max = 50,
        softMax = 10
      } },
      { "space" },
      { "differentHeights", "toggle", "Allow different heights", {
        width = "double"
      } },
      { "fonts", "header" },
      { "titleFont", "font", "Title" },
      { "titleSize", "fontSize" },
      { "space" },
      { "textFont", "font", "Text" },
      { "textSize", "fontSize" },
      { "space" },
      { "choiceFont", "font", "Choices" },
      { "choiceSize", "fontSize" },
      { "keybindings", "header" },
      { "next", "keybinding" },
      { "auto", "keybinding", "Autoselect" },
      { "back", "keybinding" },
      { "reveal", "keybinding", "Temporarily reveal Blizzard frames", { width = "double" } },
      { "space" },
      { "1", "keybinding", "Option 1", { width = "half" } },
      { "2", "keybinding", "Option 2", { width = "half" } },
      { "3", "keybinding", "Option 3", { width = "half" } },
      { "4", "keybinding", "Option 4", { width = "half" } },
      { "5", "keybinding", "Option 5", { width = "half" } },
      { "6", "keybinding", "Option 6", { width = "half" } },
      { "space" },
      { "7", "keybinding", "Option 7", { width = "half" } },
      { "8", "keybinding", "Option 8", { width = "half" } },
      { "9", "keybinding", "Option 9", { width = "half" } },
      { "10", "keybinding", "Option 10", { width = "half" } },
      { "11", "keybinding", "Option 11", { width = "half" } },
      { "12", "keybinding", "Option 12", { width = "half" } }
    } } },
    { "chat", "group", "NPC Chat", { args = {
      { "type:", "label"},
      { "yell", "toggle", { width="half" } },
      { "say", "toggle", { width="half" } },
      { "whisper", "toggle", { width="half" } },
      { "space" },
      { "instances:", "label" },
      { "none", "toggle", { width="half" } },
      { "dungeon", "toggle", { width="half" } },
      { "raid", "toggle", { width="half" } },
      { "space" },
      { "outofcombat", "toggle", "Out of combat"},
      { "incombat", "toggle", "In combat" },
      { "frame", "header" },
      { "slideSpeed", "range", "Duration (s)", {
        min = 0.5,
        max = 60,
        softMax = 20
      } },
      { "animate", "select", "Animate talking heads", {
        values = { "once", "never", "loop" }
      } },
      { "space" },
      { "width", "range", {
        min = 10,
        max = UIParent:GetWidth() or 100,
        softMin = 50,
        softMax = 700
      } },
      { "scale" },
      { "space" },
      { "adjustAlerts", "toggle", "Treat as alert" },
      { "anchor", { disabled = isAlert } },
      { "space", },
      { "offsetX", { disabled = isAlert } },
      { "offsetY", { disabled = isAlert } },
      { "space" },
      { "fonts", "header" },
      { "titleFont", "font", "Title" },
      { "titleSize", "fontSize" },
      { "space" },
      { "textFont", "font", "Text" },
      { "textSize", "fontSize" }
    } } },
    { "rp", "group", "Roleplay", { hidden = true, args = {
      { "enable", "toggle" },
      { "text", nil, "TOGGLE - /conversation rp on/off or /conv rp on/off" },
      { "text", nil, "NPC ROLEPLAY - | Sylvanas says: Greymane's forces hold this warden tower!" },
      { "ignore", "header"},
      { "((", "toggle", "((text))"},
      { "(", "toggle", "(text)" },
      { "space" },
      { "**", "toggle", "**text**" },
      { "*", "toggle", "*text*" },
      { "space" },
      { "<<", "toggle", "<<text>>" },
      { "<", "toggle", "<text>" },
      { "space" },
      { "[[", "toggle", "[[text]]" },
      { "[", "toggle", "[text]" },
      { "space" },
      { "|", "toggle", "| text (not matching \"| NPC says: \")", { width="full" } },
      { "frame", "header" },
      { "slideSpeed", "range", "Duration (s)", {
        min = 0.5,
        max = 60,
        softMax = 20
      } },
      { "animate", "select", "Animate talking heads", {
        values = { "once", "never", "loop" }
      } },
      { "space" },
      { "width", "range", {
        min = 10,
        max = UIParent:GetWidth() or 100,
        softMin = 50,
        softMax = 700
      } },
      { "scale" },
      { "space" },
      { "adjustAlerts", "toggle", "Treat as alert" },
      { "anchor", { disabled = isAlert } },
      { "space", },
      { "offsetX", { disabled = isAlert } },
      { "offsetY", { disabled = isAlert } },
      { "space" },
      { "fonts", "header" },
      { "titleFont", "font", "Title" },
      { "titleSize", "fontSize" },
      { "space" },
      { "textFont", "font", "Text" },
      { "textSize", "fontSize" }
    } } },
    { "talkinghead", "group", "Talking Head", { args = {
      { "width", "range", {
        min = 10,
        max = UIParent:GetWidth() or 100,
        softMin = 50,
        softMax = 700
      } },
      { "scale" },
      { "fonts", "header" },
      { "titleFont", "font", "Title" },
      { "titleSize", "fontSize" },
      { "space" },
      { "textFont", "font", "Text" },
      { "textSize", "fontSize" }
    } } }
  }
}
)
Settings.defaults = defaults

Settings.debug = {
}